/*____________________________________________________________________________*\
 *

 Copyright (c) 1997 John Roy. All rights reserved.

 These sources, libraries and applications are
 FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
 as long as the following conditions are adhered to.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer. 

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.

 3. Redistributions of any form whatsoever and all advertising materials 
    mentioning features must contain the following
    acknowledgment:
    "This product includes software developed by John Roy
    (http://www.johnroy.com/pi3/)."

 THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE AUTHORS OR ITS CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 OF THE POSSIBILITY OF SUCH DAMAGE.

 *____________________________________________________________________________*|
 *
 * $Source: Pi3Str.h$
 * $Date: Sun Aug 10 06:36:34 1997$
 *
 Description:
\*____________________________________________________________________________*/
/* $HeaderTop:$ */

#ifndef PI3STR_H_
#define PI3STR_H_

#include "Pi3API.h"

/*____________________________________________________________________________*\
 *
 * For binary compatibility, the type Pi3String is opaque outside of the 
	implementation library.
\*____________________________________________________________________________*/
#if defined(PI3_INTERNAL)

/* Internal */
typedef struct PIString Pi3String;

#else

/* External */
typedef int Pi3String;

#endif

/*____________________________________________________________________________*\
 *
 Name:
	Pi3String_new

 Synopsis:
	Pi3String *Pi3String_new( const char *pString );

 Description:
	This function is not yet documented.

 Notes:
	The parameter pString may be NULL to indicate an empty string.

 Return Values:
 Errors:
 See Also:
\*____________________________________________________________________________*/
PUBLIC_PIAPI Pi3String *Pi3String_new( const char *pString );

/*____________________________________________________________________________*\
 *
 Name:
	Pi3String_newEx

 Synopsis:
	Pi3String *Pi3String_newEx( const char *pString, int iLength );

 Description:
	This function is not yet documented.

 Notes:
 Return Values:
 Errors:
 See Also:
\*____________________________________________________________________________*/
PUBLIC_PIAPI Pi3String *Pi3String_newEx( const char *pString, int iLength );

/*____________________________________________________________________________*\
 *
 Name:
	Pi3String_delete

 Synopsis:
	int Pi3String_delete( Pi3String *pString );

 Description:
	This function is not yet documented.

 Notes:
 Return Values:
 Errors:
 See Also:
\*____________________________________________________________________________*/
PUBLIC_PIAPI int Pi3String_delete( Pi3String *pString );

/*____________________________________________________________________________*\
 *
 Name:
	Pi3String_getPtr

 Synopsis:
	const char *Pi3String_getPtr( Pi3String *pString );

 Description:
	This function is not yet documented.

 Notes:
 Return Values:
 Errors:
 See Also:
\*____________________________________________________________________________*/
PUBLIC_PIAPI const char *Pi3String_getPtr( const Pi3String *pString );

/*____________________________________________________________________________*\
 *
 Name:
	Pi3String_getLength

 Synopsis:
	int Pi3String_getLength( Pi3String *pString );

 Description:
	This function is not yet documented.

 Notes:
 Return Values:
 Errors:
 See Also:
\*____________________________________________________________________________*/
PUBLIC_PIAPI int Pi3String_getLength( const Pi3String *pString );

#endif	/* PI3STR_H_ */

